// image diffusion
//  
#include <stdbool.h>

// #### OpenClose.c
int ConnectToPrinter(const char *port);
int DisconnectPrinter();
int InitializePrinter();

// #### basicFunc.c
int PrintText(const char *text, const int alignment,
			  const unsigned int attribute, const unsigned int textSize);		// POS, Mobile

int PrintTextW(const char *text, const int alignment,
			  const unsigned int attribute, const unsigned int textSize, const unsigned int codePage);		// POS, Mobile

int LineFeed(const unsigned int lineNum);		// POS, Mobile

int SelectMode(bool labelMode);		// Mobile
int AutoCalibration();	// Mobile
int NextPrintPos();		// Mobile

int DirectIO(char *writeData, int writeLen, char *readData, int *readLen, unsigned int mTimeout);		// POS, Mobile
int SetLeftMargin(long margin);		// POS, Mobile
int SetUpsideDown(bool upsideDown); // POS, Mobile
int SetInternationalChar(long val); // POS, Mobile
int GetInternationalChar(); // POS, Mobile
int SetCharSet(long val); // POS, Mobile
int GetCharSet(); // POS, Mobile

int PartialCut();	// POS
int OpenCashDrawer(unsigned int milliSec); // POS

// #### barcode.c
typedef struct _barcodeInfo
{
	unsigned int mode;
	unsigned int height;
	unsigned int width;
	unsigned char eccLevel;
	unsigned int alignment;
	unsigned int textPosition;
	unsigned int attribute;
} barcodeInfo_s;

int PrintBarcode(const int barcodeType, const char *barcodeData, const barcodeInfo_s *barcodeInfo);		// POS, Mobile

// #### image.c
int PrintImage(const char *imagePath, const int width, const bool compress, const unsigned int alignment); 		// POS, Mobile
int DownloadNVImage(const char *imagePath, const unsigned int keyCode);	// POS, Mobile
int PrintNVImage(const unsigned int keyCode);		// POS, Mobile
int RemoveAllNVImage();		// POS, Mobile
int RemoveNVImage(const unsigned int keyCode);		// POS, Mobile
int GetNVImageKeyCode(char *keyCodeList, unsigned int *listLen);		// POS, Mobile

// #### pageMode.c
int SelectPageMode(bool pageMode);		// POS, Mobile
int SetPrintAreaInPM(long x, long y, long width, long height);		// POS, Mobile
int SetPrintDirectionInPM(int printDirection);		// POS, Mobile
int SetVerticalPositionInPM(long position, bool relative);		// POS, Mobile
int SetHorizontalPositionInPM(long position, bool relative);		// POS, Mobile
int PrintDataInPM();		// POS, Mobile


// #### MSR.c
long ReadStartMSR();
long ReadCancelMSR();
long ReadMSRData(char *pMSRData1, char *pMSRData2, char *pMSRData3, const unsigned int bufLen);

// #### SCR.c
long ScrPowerDown(char *pResponse);
long ScrPowerUp(char *pATR, unsigned int *ATRLen, char *pResponse);
long ScrExchangeAPDU(const char *APDUCmd, unsigned int APDULen, char *APDURsp, unsigned int *APDURspLen, char *pResponse);
long ScrOperationMode(const int mode, char *pResponse);
long ScrCheckCardStatus(char *status, char *pResponse);
long ScrSelectCard(const int card, char *pResponse);
long ScrGetCard();

// #### status.c
int SetAutoStatusCheck(bool enable);
int GetStatus();
int getBatteryStatus();
