#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>

#include "BxlPosAPI.h"
#include "bxlConst.h"

bool gEnableStatus;

int connectToPrinter()
{
	int input;
	int ret;
	char port[128] = {0x00, };

	printf("\n\t [Connect to the Bixolon printer] \n");
	printf("\t\t  1.USB\n");
	printf("\t\t  2.Serial\n");
	printf("\t\t  3.Parallel\n");
	printf("\t\t  4.Bluetooth\n");
	printf("\t\t  5.Ethernet/WLAN\n");
	printf("\t\t  6.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the connected interface with the printer.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = ConnectToPrinter("USB:");
		}
		else if (2 == input)
		{
			unsigned long baudrate = 0;

			while (1)
			{
				printf("\nPlease input the baudrate of serial I/F\n");
				printf("Input number : ");
				scanf("%lu", &baudrate);

				if (2400 != baudrate && 4800 != baudrate && 9600 != baudrate && 19200 != baudrate && 
						38400 != baudrate && 57600 != baudrate && 115200 != baudrate)
				{
					printf("\nWrong input. %lu\n", baudrate);
					continue;
				}

				break;
			}

			sprintf(port, "serial:%lu", baudrate);

			// input type
			// serial:baudrate
			// /dev/ttyX:baudrate
			ret = ConnectToPrinter(port);
		}
		else if (3 == input)
		{
			// input type
			// parallel
			// /dev/lpX
			ret = ConnectToPrinter("parallel");
		}
		else if (4 == input)
		{
			while (1)
			{
				printf("\nPlease input the mac address of bluetooth priner\n");
				printf("Input the address : ");
				scanf("%s", port);

				/*
				printf("%02x %c\n", port[0], port[0]);
				printf("%02x %c\n", port[1], port[1]);
				printf("%02x %c\n", port[2], port[2]);
				printf("%02x %c\n", port[3], port[3]);
				printf("%02x %c\n", port[4], port[4]);
				printf("%02x %c\n", port[5], port[5]);
				printf("%02x %c\n", port[6], port[6]);
				printf("%02x %c\n", port[7], port[7]);
				printf("%02x %c\n", port[8], port[8]);
				printf("%02x %c\n", port[9], port[9]);
				printf("%02x %c\n", port[10], port[10]);
				printf("%02x %c\n", port[11], port[11]);
				printf("%02x %c\n", port[12], port[12]);
				printf("%02x %c\n", port[13], port[13]);
				printf("%02x %c\n", port[14], port[14]);
				printf("%02x %c\n", port[15], port[15]);
				printf("%02x %c\n", port[16], port[16]);
				printf("%02x %c\n", port[17], port[17]);
				*/

				if (':' == port[2] && ':' == port[5] && ':' == port[8] &&
						':' == port[11] && ':' == port[14])
				{
					break;
				}

				printf("\nWrong input.\n");
			}

			// input type
			// xx:xx:xx:xx:xx:xx
			ret = ConnectToPrinter(port);
		}
		else if (5 == input)
		{
			char *tmp;

			while (1)
			{
				printf("\nPlease input the IP address of Ethernet or Wlan printer\n");
				printf("Input the address : ");
				scanf("%s", port);

				tmp = strchr(port, ':');
				if (NULL == tmp)
				{
					printf("\nWrong input.\n");

					continue;
				}

				break;
			}

			// input type
			// xxx.xxx.xxx.xxx:xxxx
			ret = ConnectToPrinter(port);
		}
		else if (6 == input)
		{
			return input;
		}
		else 
		{
			printf("\nWrong input.\n\n");

			continue;
		}

		if (SUCCESS == ret)
		{
			break;
		}
		else
		{
			printf("\nFailed to connect to the printer.\n");
			sleep(1);
		}
	}

	printf("\nSuccessed to connect to the printer.\n");
	sleep(1);

	return ret;
}


int setProperties()
{
	int input;
	int ret = SUCCESS;

	printf("\n\t [Set the Properties of the printer] \n");
	printf("\t\t  1. Left Margin\n");
	printf("\t\t  2. Upside Down\n");
	printf("\t\t  3. International Character Set\n");
	printf("\t\t  4. Charactore Set\n");
	printf("\t\t  5. Label Mode\n");
	printf("\t\t  6. Receipt Mode\n");
	printf("\t\t  7. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);


		if (1 == input)		// Left Margin
		{
			int margin;

			printf("[Set Left Margin]\n");
			printf("\nInput the Margin (1 ~ 65535): ");
			scanf("%d", &margin);

			ret = SetLeftMargin(margin);
			if (SUCCESS != ret)
			{
				printf("Failed to set left margin\n");

				return ret;
			}
			
			printf("Success to set left margin\n");
		}
		else if (2 == input)	// Upside Down 
		{
			int upsideDown; 

			printf("[Set Upside-Down]\n");
			printf("Enable the Upside-Down (1 : on, 2 : off) : ");
			scanf("%d", &upsideDown);

			if (1 == upsideDown)
			{
				ret = SetUpsideDown(true);
			}
			else
			{
				ret = SetUpsideDown(false);
			}

			if (SUCCESS != ret)
			{
				printf("Failed to set upside-down\n");

				return ret;
			}

			printf("Success to set upside-down\n");
		}
		else if (3 == input)	// International Character Set
		{
			int iCH;

			printf("\n\t [Set International Character]\n");
			printf("\n");
			printf("\t\t  1. USA\n");
			printf("\t\t  2. FRANCE\n");
			printf("\t\t  3. GERMANY\n");
			printf("\t\t  4. U.K\n");
			printf("\t\t  5. DENMARK I\n");
			printf("\t\t  6. SWEDEN\n");
			printf("\t\t  7. ITALY\n");
			printf("\t\t  8. SPAIN I\n");
			printf("\t\t  9. NORWAY\n");
			printf("\t\t  10. DENMARK II\n");
			printf("\t\t  11. SPAIN II\n");
			printf("\t\t  12. LATIN AMERICA\n");
			printf("\t\t  13. KOREA\n");

			printf("\nInput number : ");
			scanf("%d", &iCH);

			switch (iCH)
			{
				case 1:
					ret = SetInternationalChar(ICS_USA);
					break;
				case 2:
					ret = SetInternationalChar(ICS_FRANCE);
					break;
				case 3:
					ret = SetInternationalChar(ICS_GERMANY);
					break;
				case 4:
					ret = SetInternationalChar(ICS_UK);
					break;
				case 5:
					ret = SetInternationalChar(ICS_DENMARK1);
					break;
				case 6:
					ret = SetInternationalChar(ICS_SWEDEN);
					break;
				case 7:
					ret = SetInternationalChar(ICS_ITALY);
					break;
				case 8:
					ret = SetInternationalChar(ICS_SPAIN);
					break;
				case 9:
					ret = SetInternationalChar(ICS_NORWAY);
					break;
				case 10:
					ret = SetInternationalChar(ICS_DENMARK2);
					break;
				case 11:
					ret = SetInternationalChar(ICS_SPAIN2);
					break;
				case 12:
					ret = SetInternationalChar(ICS_LATIN);
					break;
				case 13:
					ret = SetInternationalChar(ICS_KOREA);
					break;
			}

			if (SUCCESS != ret)
			{
				printf("Failed to set international character set.\n");

				return ret;
			}

			printf("Success to set international character set.\n");
		}
		else if (4 == input)	// Character Set
		{
			int ch;

			printf("\n\t [Set Character]\n");
			printf("\n");
			printf("\t\t  1.PC437\n");		
			printf("\t\t  2.KATAKANA\n");	
			printf("\t\t  3.PC850\n");	
			printf("\t\t  4.PC860\n");	
			printf("\t\t  5.PC863\n");	
			printf("\t\t  6.PC865\n");	
			printf("\t\t  7.WPC1252\n");	
			printf("\t\t  8.PC866\n");	
			printf("\t\t  9.PC852\n");	
			printf("\t\t  10.PC858\n");	
			printf("\t\t  11.PC864\n");	
			printf("\t\t  12.PC874\n");	
			printf("\t\t  13.WPC1253\n");	
			printf("\t\t  14.WPC1254\n");	
			printf("\t\t  15.WPC1257\n");	
			printf("\t\t  16.FARSI\n");	
			printf("\t\t  17.WPC1251\n");	
			printf("\t\t  18.PC737\n");	
			printf("\t\t  19.PC775\n");	
			printf("\t\t  20.THAI14\n");	
			printf("\t\t  21.PC862\n");	
			printf("\t\t  22.PC855\n");	
			printf("\t\t  23.PC857\n");	
			printf("\t\t  24.PC928\n");	
			printf("\t\t  25.THAI16\n");	
			printf("\t\t  26.WPC1256\n");	
			printf("\t\t  27.PC1258\n");	
			printf("\t\t  28.KHMER\n");	
			printf("\t\t  29.PC1250\n");	
 
			printf("\nInput number : ");
			scanf("%d", &ch);

			ret = SetCharSet(ch - 1);

			if (SUCCESS != ret)
			{
				printf("Failed to set chracter set.\n");

				return ret;
			}

			printf("Success to set chracter set.\n");
		}
		else if (5 == input)	// Label Mode
		{
			printf("[Set Label Mode]\n");
			printf("\n");
			
			ret = SelectMode(true);

			if (SUCCESS != ret)
			{
				printf("Failed to set label mode.\n");

				return ret;
			}

			printf("Success to set label mode.\n");
		}
		else if (6 == input)	// Receipt Mode
		{
			printf("[Set Receipt Mode]\n");
			printf("\n");
			
			ret = SelectMode(false);

			if (SUCCESS != ret)
			{
				printf("Failed to set receipt mode.\n");

				return ret;
			}

			printf("Success to set receipt mode.\n");
		}
		else if (7 == input)
		{
			return input;
		}
		else
		{
			printf("\nWrong input.\n\n");

			continue;
		}
	}

	return SUCCESS;
}

int printSample()
{
	PrintText("            RECEIPT          \n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("------------------------------\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Apple         3         $3.0\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Cola          1         $1.2\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Milk          2         $1.8\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Juice         1         $2.0\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("------------------------------\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Total                   $8.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Cash                    $8.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("                         $0.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);


	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_B, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_C, TS_HEIGHT_0 | TS_WIDTH_0);

	LineFeed(5);

	return SUCCESS;
}

int printText()
{
	char *testMsg = "BIXOLON LINUX SDK TEST.\n\n";
	char *test = "한국어";

	PrintTextW(test, ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0, ENCODING_EUCKR);
	PrintText("\n\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);

	PrintText(testMsg, ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(testMsg, ALIGNMENT_CENTER, ATTR_FONTTYPE_B, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(testMsg, ALIGNMENT_RIGHT, ATTR_FONTTYPE_C, TS_HEIGHT_0 | TS_WIDTH_0);
	
	PrintText(testMsg, ALIGNMENT_LEFT, ATTR_FONTTYPE_A | ATTR_BOLD, TS_HEIGHT_1 | TS_WIDTH_1);
	PrintText(testMsg, ALIGNMENT_CENTER, ATTR_FONTTYPE_B | ATTR_BOLD | ATTR_REVERSE, TS_HEIGHT_1 | TS_WIDTH_1);
	PrintText(testMsg, ALIGNMENT_RIGHT, ATTR_FONTTYPE_C | ATTR_BOLD | ATTR_UNDERLINE_1, TS_HEIGHT_1 | TS_WIDTH_1);

	return SUCCESS;
}

int printBarcode()
{
	char *barcodeData = "123456789012";
	barcodeInfo_s barcodeInfo;

	PrintText("UPCA\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_UPCA, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("UPCE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_UPCE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("EAN13\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_EAN13, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("JAN13\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_JAN13, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("EAN8\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_EAN8, "12345678", &barcodeInfo);
	LineFeed(2);

	PrintText("JAN8\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_JAN8, "12345678", &barcodeInfo);
	LineFeed(2);

	PrintText("Code 39\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE39, barcodeData, &barcodeInfo);
	LineFeed(2);
	
	PrintText("Code 93\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE93, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("Code 128\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE128, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("ITF\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_ITF, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("Codabar\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODABAR, barcodeData, &barcodeInfo);
	LineFeed(2);

	
	// ************************************** 2D barcode

	PrintText("PDF417\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_PDF417, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("QRCODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_QR_MODEL1;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_QRCODE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("QRCODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_QR_MODEL2;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_QRCODE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("DATAMATRIX\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_DATAMATRIX, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("MAXICODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_MAXI_MODE4;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_MAXICODE, barcodeData, &barcodeInfo);

	LineFeed(5);

	PartialCut();

	return SUCCESS;
}

int printPageMode()
{
	char *barcode = "1234567890123";
	barcodeInfo_s barcodeInfo;

	SelectPageMode(true);
	SetPrintAreaInPM(0, 0, 416, 416);
	SetPrintDirectionInPM(PAGEMODE_ROTATE_90);

	SetVerticalPositionInPM(70, false);
	SetHorizontalPositionInPM(5, false);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_NONE;
	PrintBarcode(BARCODE_CODE93, barcode, &barcodeInfo); 

	SetVerticalPositionInPM(155, false);
	SetHorizontalPositionInPM(80, false);
	PrintText(barcode, ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);

	SetVerticalPositionInPM(200, false);
	SetHorizontalPositionInPM(0, false);
	PrintText("Name :", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	SetVerticalPositionInPM(200, false);
	SetHorizontalPositionInPM(90, false);
	PrintText("Frank", ALIGNMENT_CENTER, ATTR_FONTTYPE_A | ATTR_UNDERLINE_2 | ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);

	SetVerticalPositionInPM(200, false);
	SetHorizontalPositionInPM(180, false);
	PrintText("Sex :", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	SetVerticalPositionInPM(200, false);
	SetHorizontalPositionInPM(260, false);
	PrintText("male", ALIGNMENT_CENTER, ATTR_FONTTYPE_A | ATTR_UNDERLINE_2 | ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);

	SetVerticalPositionInPM(250, false);
	SetHorizontalPositionInPM(0, false);
	PrintText("Age :", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	SetVerticalPositionInPM(250, false);
	SetHorizontalPositionInPM(90, false);
	PrintText(" 30 ", ALIGNMENT_CENTER, ATTR_FONTTYPE_A | ATTR_UNDERLINE_2 | ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);

	SetVerticalPositionInPM(250, false);
	SetHorizontalPositionInPM(180, false);
	PrintText("City :", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	SetVerticalPositionInPM(250, false);
	SetHorizontalPositionInPM(260, false);
	PrintText(" Seoul ", ALIGNMENT_CENTER, ATTR_FONTTYPE_A | ATTR_UNDERLINE_2 | ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);

	SetVerticalPositionInPM(360, false);
	SetHorizontalPositionInPM(60, false);
	PrintText("abcdefgHIJK-123", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);

	PrintDataInPM();

	LineFeed(2);
	PartialCut();

	return SUCCESS;
}

int testNVImage()
{
	int input;
	int ret = SUCCESS;

	printf("\n\t [Test NVImage Function] \n");
	printf("\t\t  1. Download NV Image\n");
	printf("\t\t  2. Print NV Image\n");
	printf("\t\t  3. Remove NV Image\n");
	printf("\t\t  4. Remove All NV Image\n");
	printf("\t\t  5. Get NV Image Key\n");
	printf("\t\t  6. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = DownloadNVImage("image.bmp", 0x01);
			if (SUCCESS != ret)
			{
				printf("Failed to download NV Image\n");

				return ret;
			}

			printf("Success to download NV Image\n");

		}
		else if (2 == input)
		{
			ret = PrintNVImage(0x01);
			if (SUCCESS != ret)
			{
				printf("Failed to print NV Image\n");

				return ret;
			}

			printf("Success to print NV Image\n");
		}
		else if (3 == input)
		{
			ret = RemoveNVImage(0x00);
			if (SUCCESS != ret)
			{
				printf("Failed to remove NV Image\n");

				return ret;
			}

			printf("Success to print NV Image\n");
		}
		else if (4 == input)
		{
			ret = RemoveAllNVImage();
			if (SUCCESS != ret)
			{
				printf("Failed to remove all NV Image\n");

				return ret;
			}

			printf("Success to remove all NV Image\n");
		}
		else if (5 == input)
		{
			char keyList[128] = {0x00,};
			unsigned int listLen = 0;
			int i = 0;

			ret = GetNVImageKeyCode(keyList, &listLen);
			if (SUCCESS != ret)
			{
				printf("Failed to get NV Image key code\n");

				return ret;
			}

			printf("Success to get NV Image key code\n");

			for (i = 0; i < listLen; i++)
			{
				printf("%02x ", keyList[i]);
			}
			printf("\n");
		}
		else if (6 == input)
		{
			return input;	
		}
	}

	return ret;
}

int testMSR()
{
	int input;
	int ret = SUCCESS;
	char track1[MSR_TRACK_LEN] = {0x00,};
	char track2[MSR_TRACK_LEN] = {0x00,};
	char track3[MSR_TRACK_LEN] = {0x00,};


	printf("\n\t [Test MSR Function] \n");
	printf("\t\t  1. Enable MSR\n");
	printf("\t\t  2. Disable MSR\n");
	printf("\t\t  3. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ReadStartMSR();

			ret = ReadMSRData(track1, track2, track3, MSR_TRACK_LEN);
			printf("Track1 : %s\n", track1);
			printf("Track2 : %s\n", track2);
			printf("Track3 : %s\n", track3);
		}
		else if (2 == input)
		{
			ReadCancelMSR();
		}
		else if (3 == input)
		{
			break;
		}
	}

	return ret;
}

int testSCR()
{
	int input;
	int ret = SUCCESS;
	char response = 0xff;
	char pATR[512] = {0x00, };
	unsigned int atrLen = 512;

	printf("\n\t [Test SCR Function] \n");
	printf("\t\t  1. Power Up\n");
	printf("\t\t  2. Power Down\n");
	printf("\t\t  3. Check Card Status\n");
	printf("\t\t  4. Select Card\n");
	printf("\t\t  5. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = ScrPowerUp(pATR, &atrLen, &response);
			if (SUCCESS != ret)
			{
				printf("Failed ScrPowerUp\n");

				return ret;
			}

			if (0x00 != response)
			{
				printf("Failed ScrPowerUp\n");

				return SCR_RESPONSE_ERROR;
			}

			printf("Success ScrPowerUp");
		}
		else if (2 == input)
		{
			ret = ScrPowerDown(&response);
			if (SUCCESS != ret)
			{
				printf("Failed ScrPowerDown\n");

				return ret;
			}

			if (0x00 != response)
			{
				printf("Failed ScrPowerDown\n");

				return SCR_RESPONSE_ERROR;
			}

			printf("Success ScrPowerDOwn\n");
		}
		else if (3 == input)
		{
			char status = 0x00;

			ret = ScrCheckCardStatus(&status, &response);
			if (SUCCESS != ret)
			{
				printf("Failed ScrCheckCardStatus\n");

				return ret;
			}

			if (0x00 != response)
			{
				printf("Failed ScrCheckCardStatus\n");

				return SCR_RESPONSE_ERROR;
			}

			if ((status & 0x03) == SCR_STS_5V)
			{
				printf("Power 5V\n");
			}
			else if ((status & 0x03) == SCR_STS_3V)
			{
				printf("Power 3V\n");
			}
			else
			{
				printf("Power 1.8V\n");
			}

			if ((status & SCR_STS_POWERED) != 0)
			{
				printf("Card is powered\n");
			}
			else
			{
				printf("Card is not powered\n");
			}

			if ((status & SCR_STS_INSERTED) != 0)
			{
				printf("Card is inserted\n");
			}
			else
			{
				printf("Card is not inserted\n");
			}
		}
		else if (4 == input)
		{
			printf("\n\t [Select SCR Card]\n");
			printf("\n");
			printf("\t\t  1. Smart Card\n");
			printf("\t\t  2. SAM1\n");
			printf("\t\t  3. SAM2\n");

			printf(" input number :");
			scanf("%d", &input);

			if (1 == input)
			{
				ret = ScrSelectCard(SCR_SMARTCARD, &response);

				if (SUCCESS != ret)
				{
					printf("Failed to select smart card\n");

					return ret;
				}

				if (0x30 != response)
				{
					printf("Failed to select smart card\n");

					return SCR_RESPONSE_ERROR;
				}

				printf("Success to select smart card\n");
			}
			else if (2 == input)
			{
				ret = ScrSelectCard(SCR_SAM1, &response);

				if (SUCCESS != ret)
				{
					printf("Failed to select SAM1\n");

					return ret;
				}

				if (0x31 != response)
				{
					printf("Failed to select SAM1\n");

					return SCR_RESPONSE_ERROR;
				}
				
				printf("Success to select smart card\n");
			}
			else if (3 == input)
			{
				ret = ScrSelectCard(SCR_SAM2, &response);

				if (SUCCESS != ret)
				{
					printf("Failed to select SAM2\n");

					return ret;
				}

				if (0x32 != response)
				{
					printf("Failed to select SAM2\n");

					return SCR_RESPONSE_ERROR;
				}

				printf("Success to select smart card\n");
			}
		}
		else if (5 == input)
		{
			return input;
		}
	}

	return ret;
}

void *cCheckStatus(void *arg)
{
	int status = 0x00;

	while (true == gEnableStatus)
	{
		status = GetStatus();

		if (READ_TIMEOUT == status)
		{
			continue;
		}

		printf("\nstatus : %02x\n", status);
		
		if (0x00 == status)
		{
			printf("Printer Normal\n");
		}
		else 
		{
			if (status & STS_COVEROPEN)
			{
				printf("Printer Error : Cover open\n");
			}

			if (status & STS_NEAREND)
			{
				printf("Printer Error : Near end\n");
			}

			if (status & STS_PAPEREMPTY)
			{
				printf("Printer Error : Paper empty\n");
			}
		}

		printf("If you wanna quit checking ASB, please input the number 2.\n");
	}

	return NULL;
}


int checkStatus()
{
	int input;
	int error;
	pthread_t tid;
	void *res;

	printf("\n\t [Check Status] \n");
	printf("\t\t  1. Enable ASB\n");
	printf("\t\t  2. Disable ASB\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			SetAutoStatusCheck(true);
			gEnableStatus = true;

			if (0 != (error = pthread_create(&tid, NULL, cCheckStatus, NULL)))
			{
				printf("Failed to create thread.");
				return -1;
			}
		}
		else 
		{
			SetAutoStatusCheck(false);
			gEnableStatus = false;

			pthread_join(tid, &res);

			break;
		}
	}

	return SUCCESS;
}

int main()
{
	int menu_flag = 0;
	int ret;

	unsigned int input;

	gEnableStatus = false;

	while (1)
	{
		system("clear");
		printf("\n\n   [Bixolon Mobile Printer SDK Sample]   \n\n");

		if (0 == menu_flag)
		{
			printf("\t 1. Connect to the printer\n");
		}
		else 
		{
			printf("\t 1. Connect to the printer\n");
			printf("\t  - Connected!\n");
		}
		printf("\t 2. Set Properties\n");
		printf("\t 3. Print Sample\n");
		printf("\t 4. Print Text\n");
		printf("\t 5. Print Barcode\n");
		printf("\t 6. Print Image\n");
		printf("\t 7. Print Page Mode\n");
		printf("\t 8. Test NVImage\n");
		printf("\t 9. Test MSR\n");
		printf("\t 10. Test SCR\n");
		printf("\t 11. Check Status\n");
		printf("\t 12. Test Feed\n");
		printf("\t 13. Test DirectIO\n");
		printf("\t 14. Get Battery Status (SPP-R200III)\n");
		printf("\t 15. Get Battery Status (SPP-A200)\n");
		printf("\t 16. Exit\n");

		fflush(stdin);
		input = 0x00;
		printf("  input number : ");
		scanf("%d", &input);


		if (1 == input)		// connect to the printer
		{
			ret = connectToPrinter();
			if (6 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");

				return -1;
			}

			menu_flag = 1;
		}
		else if (2 == input) 	// set properties
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = setProperties();
			if (7 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");
				continue;
			}

			menu_flag = 2;
		}
		else if (3 == input) 	// print sample
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			
			printSample();

			menu_flag = 3;
		}
		else if (4 == input) 	// print text
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			printText();

			menu_flag = 4;
		}
		else if (5 == input) 	// print barcode
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			printBarcode();

			menu_flag = 5;
		}
		else if (6 == input) 	// print image
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			PrintImage("image.bmp", 350, false, ALIGNMENT_CENTER);
			PrintImage("image.jpg", 350, false, ALIGNMENT_CENTER);
			PrintImage("image.gif", 350, false, ALIGNMENT_CENTER);
			LineFeed(10);
			PartialCut();

			menu_flag = 6;
		}
		else if (7 == input) 	// print page mode
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			printPageMode();

			menu_flag = 7;
		}
		else if (8 == input) 	// test NVImage
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = testNVImage();

			if (6 == ret)
			{
				continue;
			}

			menu_flag = 8;
		}
		else if (9 == input) 	// test MSR
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			testMSR();

			menu_flag = 9;
		}
		else if (10 == input) 	// test SCR
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			break;

			ret = testSCR();

			if (5 == input)
			{
				continue;
			}

			menu_flag = 10;
		}
		else if (11 == input) 	// check status
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			checkStatus();

			menu_flag = 11;
		}
		else if (12 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			LineFeed(10);

			menu_flag = 12;
		}
		else if (13 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			char readBuf[4] = {0x00,};
			int readLen = 0, i = 0;

			DirectIO("\x10\x04\x01", 3, NULL, NULL, 0); 

			usleep(3000);

			DirectIO(NULL, 0, readBuf, &readLen, 1000); 

			printf("Read Data : ");
			for (i = 0; i < readLen; i++)
			{
				printf("%02x ", readBuf[i]);
			}
			printf("\n");

			sleep(1);

			menu_flag = 13;
		}
		else if (14 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			char BatteryStatus[4][7]={"FULL","HIGH","MIDDLE","LOW"};			
			int batsta = getBatteryStatus();
			if(batsta == -1) printf("Failed to Get Battery Data\n");
			else printf("%s\n",BatteryStatus[batsta]);
			menu_flag = 14;
		}
		else if (15 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			int batsta = getBatteryStatus();
			if(batsta == -1) printf("Failed to Get Battery Data\n");
			else printf("%d%%\n",batsta);

			menu_flag = 15;
		}
		
		else if (16 == input) 	// exit
		{
			printf("\n **** Finish **** \n");
			DisconnectPrinter();
			menu_flag = 16;
			break;
		}
		else 
		{
			printf("Wrong Input!!\n");

			continue;
		}

	}


	return 0;
}

